unit Errlog;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls;

type
  TErrLogWnd = class(TForm)
    ListBox1: TListBox;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1MeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AddErr(typ, str:string);
  end;

var
  ErrLogWnd: TErrLogWnd;

procedure AddError(typ, str:string);

implementation


{$R *.DFM}

procedure AddError(typ, str:string);
begin
  if ErrLogWnd = nil then
  begin
    ErrLogWnd := TErrLogWnd.create(application.MainForm);
  end;

  ErrLogWnd.addErr(typ, str);
  ErrLogWnd.Show;
  ErrLogWnd.SetFocus;
end;

procedure TErrLogWnd.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_escape then close;
end;

procedure TErrLogWnd.AddErr(typ, str:string);
begin
  if ListBox1.items.count > 100 then
    ListBox1.items.delete(0);
  ListBox1.items.add(typ+#9+str);
  ListBox1.itemIndex := ListBox1.items.count - 1;
end;


procedure TErrLogWnd.FormCreate(Sender: TObject);
var
  tabs:array[0..3] of integer;
  lp:longInt;
begin
  tabs[0] := 40;
  tabs[1] := 220;
  lp := GetWindowLong(listbox1.handle, GWL_STYLE) or LBS_USETABSTOPS;
  SetWindowLong(listbox1.handle, GWL_STYLE, lp);

  lp := longInt(@tabs[0]);
  lp := SendMessage(listbox1.handle, LB_SETTABSTOPS, 2, lp);
end;

procedure TErrLogWnd.ListBox1MeasureItem(Control: TWinControl;
  Index: Integer; var Height: Integer);
begin
  with ListBox1.Canvas do
  begin
    Height := TextHeight('A');
  end;
end;


procedure TErrLogWnd.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var n, l, x:integer;
  txt:string;
begin
  with ListBox1.Canvas do
  begin
    txt := ListBox1.Items[Index];
    FillRect(Rect);
    x := 1;

    Repeat
    begin
      n := pos(#9, txt);
      If n > 0 Then
        l := n - 1
      else
        l := Length(txt);
      If l > 0 Then
      begin
        TextOut(x, Rect.Top, Copy(txt, 1, l));
      end;
      If n > 0 Then
      begin
        txt := Copy(txt, n + 1, length(txt)-n);
        x := TextWidth('AAAAAAAAAAA');
      end;
    end;
    Until not (n > 0);
  end;
end;

end.
